package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static b4a.example.stringfunctiongpx _sfgpx = null;
public static b4a.example.creatorgpx _crgpx = null;
public b4a.example.main._s0_mytypes _globals_type = null;
public b4a.example.main._s1_mytypes _metadata = null;
public b4a.example.main._s2_mytypes _trk = null;
public b4a.example.main._s3_mytypes _extensions = null;
public b4a.example.main._s4_mytypes _trkseg = null;
public static class _s0_mytypes{
public boolean IsInitialized;
public String pattern;
public void Initialize() {
IsInitialized = true;
pattern = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _s1_mytypes{
public boolean IsInitialized;
public String link;
public String text;
public String time;
public anywheresoftware.b4a.objects.collections.Map bounds;
public void Initialize() {
IsInitialized = true;
link = "";
text = "";
time = "";
bounds = new anywheresoftware.b4a.objects.collections.Map();
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _s2_mytypes{
public boolean IsInitialized;
public String trkname;
public void Initialize() {
IsInitialized = true;
trkname = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _s3_mytypes{
public boolean IsInitialized;
public String TrackExtension;
public String DisplayColor;
public void Initialize() {
IsInitialized = true;
TrackExtension = "";
DisplayColor = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static class _s4_mytypes{
public boolean IsInitialized;
public String lat;
public String lon;
public String ele;
public String hms;
public void Initialize() {
IsInitialized = true;
lat = "";
lon = "";
ele = "";
hms = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 47;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 57;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 51;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 24;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 28;BA.debugLine="Type S0_MyTypes (pattern As String)";
;
 //BA.debugLineNum = 29;BA.debugLine="Dim Globals_Type As S0_MyTypes";
mostCurrent._globals_type = new b4a.example.main._s0_mytypes();
 //BA.debugLineNum = 31;BA.debugLine="Type S1_MyTypes (link As String, text As String,";
;
 //BA.debugLineNum = 32;BA.debugLine="Dim metadata As S1_MyTypes";
mostCurrent._metadata = new b4a.example.main._s1_mytypes();
 //BA.debugLineNum = 34;BA.debugLine="Type S2_MyTypes (trkname As String)";
;
 //BA.debugLineNum = 35;BA.debugLine="Dim trk As S2_MyTypes";
mostCurrent._trk = new b4a.example.main._s2_mytypes();
 //BA.debugLineNum = 37;BA.debugLine="Type S3_MyTypes (TrackExtension As String, Displa";
;
 //BA.debugLineNum = 38;BA.debugLine="Dim extensions As S3_MyTypes";
mostCurrent._extensions = new b4a.example.main._s3_mytypes();
 //BA.debugLineNum = 40;BA.debugLine="Type S4_MyTypes (lat As String, lon As String, el";
;
 //BA.debugLineNum = 41;BA.debugLine="Dim trkseg As S4_MyTypes";
mostCurrent._trkseg = new b4a.example.main._s4_mytypes();
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _initializes() throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Public Sub Initializes";
 //BA.debugLineNum = 61;BA.debugLine="Globals_Type.Initialize";
mostCurrent._globals_type.Initialize();
 //BA.debugLineNum = 62;BA.debugLine="metadata.Initialize";
mostCurrent._metadata.Initialize();
 //BA.debugLineNum = 63;BA.debugLine="trk.Initialize";
mostCurrent._trk.Initialize();
 //BA.debugLineNum = 64;BA.debugLine="extensions.Initialize";
mostCurrent._extensions.Initialize();
 //BA.debugLineNum = 65;BA.debugLine="trkseg.Initialize";
mostCurrent._trkseg.Initialize();
 //BA.debugLineNum = 66;BA.debugLine="Globals_Type.pattern = \"∆\"";
mostCurrent._globals_type.pattern = "∆";
 //BA.debugLineNum = 67;BA.debugLine="trkseg.ele = \"\"";
mostCurrent._trkseg.ele = "";
 //BA.debugLineNum = 68;BA.debugLine="trkseg.hms = \"\"";
mostCurrent._trkseg.hms = "";
 //BA.debugLineNum = 69;BA.debugLine="trkseg.lat = \"\"";
mostCurrent._trkseg.lat = "";
 //BA.debugLineNum = 70;BA.debugLine="trkseg.lon = \"\"";
mostCurrent._trkseg.lon = "";
 //BA.debugLineNum = 71;BA.debugLine="End Sub";
return "";
}
public static String  _loadfile_click() throws Exception{
String _filetostr = "";
anywheresoftware.b4a.objects.collections.Map _bounds = null;
int _i = 0;
anywheresoftware.b4a.objects.collections.List _sum_trkseg = null;
anywheresoftware.b4a.objects.collections.List _sum_wpt = null;
String _path = "";
anywheresoftware.b4a.objects.collections.List _fix_time = null;
anywheresoftware.b4a.objects.collections.List _fix_accuracy = null;
anywheresoftware.b4a.objects.collections.List _fix_altitude = null;
anywheresoftware.b4a.objects.collections.List _fix_wpts = null;
String _chr_pattern = "";
boolean _init_boolean = false;
String _fix_trkname = "";
String _displaycolor = "";
String _html_schemas = "";
String _fix_trkcmt = "";
String _filename = "";
anywheresoftware.b4a.objects.collections.List _fix_rtes = null;
anywheresoftware.b4a.objects.collections.Map _gpxx_rpt = null;
 //BA.debugLineNum = 73;BA.debugLine="Sub LoadFile_Click";
 //BA.debugLineNum = 74;BA.debugLine="Dim FileToStr As String = SFGpx.GetText(File.DirA";
_filetostr = _sfgpx._gettext(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"RTE-1-topografix.GPX");
 //BA.debugLineNum = 78;BA.debugLine="If FileToStr.Length = 0 Then";
if (_filetostr.length()==0) { 
 //BA.debugLineNum = 79;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 }else {
 //BA.debugLineNum = 93;BA.debugLine="Log(\"Returns: \" & SFGpx.MidExtract(\"<time>2012-0";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._midextract("<time>2012-01-27T10:07:32Z</time>","T","Z"));
 //BA.debugLineNum = 94;BA.debugLine="Log(\"Returns: \" & SFGpx.SplitGetWord(\"<text>Garm";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._splitgetword("<text>Garmin International</text>","<text>","</text>"," ",(int) (2)));
 //BA.debugLineNum = 95;BA.debugLine="Msgbox(SFGpx.MidExtract(\"<time>2012-01-27T10:07:";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._midextract("<time>2012-01-27T10:07:32Z</time>","T","Z"),"1"+anywheresoftware.b4a.keywords.Common.CRLF+"MidExtract",mostCurrent.activityBA);
 //BA.debugLineNum = 96;BA.debugLine="Msgbox(SFGpx.SplitGetWord(\"<text>Garmin Internat";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._splitgetword("<text>Garmin International</text>","<text>","</text>"," ",(int) (2)),"2"+anywheresoftware.b4a.keywords.Common.CRLF+"SplitGetWord",mostCurrent.activityBA);
 //BA.debugLineNum = 99;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_link_metadata)	'Retu";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_link_metadata());
 //BA.debugLineNum = 100;BA.debugLine="Msgbox(SFGpx.Get_link_metadata,\"3\"&CRLF&\"Get_lin";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_link_metadata(),"3"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_link_metadata",mostCurrent.activityBA);
 //BA.debugLineNum = 103;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_text_metadata)	'Retu";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_text_metadata());
 //BA.debugLineNum = 104;BA.debugLine="Msgbox(SFGpx.Get_text_metadata,\"4\"&CRLF&\"Get_tex";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_text_metadata(),"4"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_text_metadata",mostCurrent.activityBA);
 //BA.debugLineNum = 107;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_time_metadata)	'Retu";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_time_metadata());
 //BA.debugLineNum = 108;BA.debugLine="Msgbox(SFGpx.Get_time_metadata,\"5\"&CRLF&\"Get_tim";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_time_metadata(),"5"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_time_metadata",mostCurrent.activityBA);
 //BA.debugLineNum = 111;BA.debugLine="Dim bounds As Map";
_bounds = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 112;BA.debugLine="bounds.Initialize";
_bounds.Initialize();
 //BA.debugLineNum = 113;BA.debugLine="bounds = SFGpx.Get_bounds_metadata(\",\")	'Returns";
_bounds = _sfgpx._get_bounds_metadata(",");
 //BA.debugLineNum = 114;BA.debugLine="If bounds.Size > 0 Then";
if (_bounds.getSize()>0) { 
 //BA.debugLineNum = 115;BA.debugLine="For i = 0 To bounds.Size -1";
{
final int step54 = 1;
final int limit54 = (int) (_bounds.getSize()-1);
for (_i = (int) (0); (step54 > 0 && _i <= limit54) || (step54 < 0 && _i >= limit54); _i = ((int)(0 + _i + step54))) {
 //BA.debugLineNum = 123;BA.debugLine="Log(\"Key:   \" & bounds.GetKeyAt(i))";
anywheresoftware.b4a.keywords.Common.Log("Key:   "+BA.ObjectToString(_bounds.GetKeyAt(_i)));
 //BA.debugLineNum = 124;BA.debugLine="Log(\"Value: \" & bounds.GetValueAt(i))";
anywheresoftware.b4a.keywords.Common.Log("Value: "+BA.ObjectToString(_bounds.GetValueAt(_i)));
 //BA.debugLineNum = 125;BA.debugLine="Msgbox(\"Key:\" & bounds.GetKeyAt(i)&CRLF&\"Value";
anywheresoftware.b4a.keywords.Common.Msgbox("Key:"+BA.ObjectToString(_bounds.GetKeyAt(_i))+anywheresoftware.b4a.keywords.Common.CRLF+"Value:"+BA.ObjectToString(_bounds.GetValueAt(_i)),"6-"+BA.NumberToString(_i)+anywheresoftware.b4a.keywords.Common.CRLF+"Get_bounds_metadata",mostCurrent.activityBA);
 }
};
 };
 //BA.debugLineNum = 137;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_name_trk)	'Returns:";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_name_trk());
 //BA.debugLineNum = 138;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_TrackExtension_exten";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_trackextension_extensions());
 //BA.debugLineNum = 139;BA.debugLine="Log(\"Returns: \" & SFGpx.Get_DisplayColor_extensi";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+_sfgpx._get_displaycolor_extensions());
 //BA.debugLineNum = 140;BA.debugLine="Msgbox(SFGpx.Get_name_trk, \"7\"&CRLF&\"Get_name_tr";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_name_trk(),"7"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_name_trk",mostCurrent.activityBA);
 //BA.debugLineNum = 141;BA.debugLine="Msgbox(SFGpx.Get_TrackExtension_extensions,\"8\"&C";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_trackextension_extensions(),"8"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_TrackExtension_extensions",mostCurrent.activityBA);
 //BA.debugLineNum = 142;BA.debugLine="Msgbox(SFGpx.Get_DisplayColor_extensions,\"9\"&CRL";
anywheresoftware.b4a.keywords.Common.Msgbox(_sfgpx._get_displaycolor_extensions(),"9"+anywheresoftware.b4a.keywords.Common.CRLF+"Get_DisplayColor_extensions",mostCurrent.activityBA);
 //BA.debugLineNum = 151;BA.debugLine="Dim sum_trkseg As List";
_sum_trkseg = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 152;BA.debugLine="sum_trkseg.Initialize";
_sum_trkseg.Initialize();
 //BA.debugLineNum = 153;BA.debugLine="sum_trkseg = SFGpx.Get_trkpt_trkseg(\",\") 'Return";
_sum_trkseg = _sfgpx._get_trkpt_trkseg(",");
 //BA.debugLineNum = 155;BA.debugLine="If sum_trkseg.Size > 0 Then";
if (_sum_trkseg.getSize()>0) { 
 //BA.debugLineNum = 158;BA.debugLine="For i = 0 To sum_trkseg.Size -1";
{
final int step70 = 1;
final int limit70 = (int) (_sum_trkseg.getSize()-1);
for (_i = (int) (0); (step70 > 0 && _i <= limit70) || (step70 < 0 && _i >= limit70); _i = ((int)(0 + _i + step70))) {
 //BA.debugLineNum = 159;BA.debugLine="Log(\"Returns: \" & sum_trkseg.Get(i))";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+BA.ObjectToString(_sum_trkseg.Get(_i)));
 //BA.debugLineNum = 160;BA.debugLine="If i < 1 Then Msgbox(sum_trkseg.Get(i),\"10-\"&i";
if (_i<1) { 
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToString(_sum_trkseg.Get(_i)),"10-"+BA.NumberToString(_i)+anywheresoftware.b4a.keywords.Common.CRLF+"Get_trkpt_trkseg",mostCurrent.activityBA);};
 }
};
 };
 //BA.debugLineNum = 176;BA.debugLine="Dim sum_wpt As List";
_sum_wpt = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 177;BA.debugLine="sum_wpt.Initialize";
_sum_wpt.Initialize();
 //BA.debugLineNum = 178;BA.debugLine="sum_wpt = SFGpx.Get_wpt(\",\") 'Returns: List - <w";
_sum_wpt = _sfgpx._get_wpt(",");
 //BA.debugLineNum = 180;BA.debugLine="If sum_wpt.Size > 0 Then";
if (_sum_wpt.getSize()>0) { 
 //BA.debugLineNum = 183;BA.debugLine="For i = 0 To sum_wpt.Size -1";
{
final int step79 = 1;
final int limit79 = (int) (_sum_wpt.getSize()-1);
for (_i = (int) (0); (step79 > 0 && _i <= limit79) || (step79 < 0 && _i >= limit79); _i = ((int)(0 + _i + step79))) {
 //BA.debugLineNum = 184;BA.debugLine="Log(\"Returns: \" & sum_wpt.Get(i))";
anywheresoftware.b4a.keywords.Common.Log("Returns: "+BA.ObjectToString(_sum_wpt.Get(_i)));
 //BA.debugLineNum = 185;BA.debugLine="If i < 1 Then Msgbox(sum_wpt.Get(i),\"11-\"&i&CR";
if (_i<1) { 
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToString(_sum_wpt.Get(_i)),"11-"+BA.NumberToString(_i)+anywheresoftware.b4a.keywords.Common.CRLF+"Get_wpt",mostCurrent.activityBA);};
 }
};
 };
 };
 //BA.debugLineNum = 202;BA.debugLine="Dim path As String = File.DirRootExternal";
_path = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal();
 //BA.debugLineNum = 204;BA.debugLine="Dim Fix_time, Fix_accuracy, Fix_altitude, Fix_wpt";
_fix_time = new anywheresoftware.b4a.objects.collections.List();
_fix_accuracy = new anywheresoftware.b4a.objects.collections.List();
_fix_altitude = new anywheresoftware.b4a.objects.collections.List();
_fix_wpts = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 205;BA.debugLine="Dim Chr_pattern As String = \",\"";
_chr_pattern = ",";
 //BA.debugLineNum = 206;BA.debugLine="Dim init_boolean As Boolean";
_init_boolean = false;
 //BA.debugLineNum = 207;BA.debugLine="Dim Fix_trkname As String = \"TRACK-01\"";
_fix_trkname = "TRACK-01";
 //BA.debugLineNum = 208;BA.debugLine="Dim DisplayColor As String = \"Blue\" 'see: <gpxx:D";
_displaycolor = "Blue";
 //BA.debugLineNum = 209;BA.debugLine="Dim html_schemas As String = \"http://www.garmin.c";
_html_schemas = "http://www.garmin.com/xmlschemas/GpxExtensions/v3";
 //BA.debugLineNum = 210;BA.debugLine="Dim Fix_trkcmt As String = \"Gefahrener Weg\" 'see:";
_fix_trkcmt = "Gefahrener Weg";
 //BA.debugLineNum = 213;BA.debugLine="init_boolean = CRGpx.Initialize(path, Fix_trkname";
_init_boolean = _crgpx._initialize(processBA,_path,_fix_trkname,_fix_time,_fix_accuracy,_fix_altitude,_fix_wpts,_chr_pattern);
 //BA.debugLineNum = 215;BA.debugLine="If init_boolean Then";
if (_init_boolean) { 
 //BA.debugLineNum = 219;BA.debugLine="Dim path As String = CRGpx.Globals_Type.SavedFil";
_path = _crgpx._globals_type.SavedFilePath;
 //BA.debugLineNum = 220;BA.debugLine="Dim filename As String = \"RTE-1-topografix.GPX\"";
_filename = "RTE-1-topografix.GPX";
 //BA.debugLineNum = 223;BA.debugLine="CRGpx.SetBounds(\"51.8661866\",\"7.4931479\",\"51.613";
_crgpx._setbounds("51.8661866","7.4931479","51.6139841","7.3194265");
 //BA.debugLineNum = 225;BA.debugLine="If CRGpx.CreateFileTracks(path, filename, Fix_tr";
if (_crgpx._createfiletracks(_path,_filename,_fix_trkname,_displaycolor,_fix_trkcmt,_fix_time,_fix_accuracy,_fix_altitude,_fix_wpts,_html_schemas)) { 
 //BA.debugLineNum = 228;BA.debugLine="Msgbox(\"C R E A T E\" & CRLF & filename, \"III. M";
anywheresoftware.b4a.keywords.Common.Msgbox("C R E A T E"+anywheresoftware.b4a.keywords.Common.CRLF+_filename,"III. Message",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 231;BA.debugLine="Msgbox(\"E R R O R\" & CRLF & LastException.Messa";
anywheresoftware.b4a.keywords.Common.Msgbox("E R R O R"+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"III. Message",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 236;BA.debugLine="Dim path As String = CRGpx.Globals_Type.SavedFil";
_path = _crgpx._globals_type.SavedFilePath;
 //BA.debugLineNum = 237;BA.debugLine="Dim filename As String = \"RTE-2-topografix.GPX\"";
_filename = "RTE-2-topografix.GPX";
 //BA.debugLineNum = 238;BA.debugLine="Dim Fix_rtes As List";
_fix_rtes = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 241;BA.debugLine="CRGpx.SetBounds(\"51.8661866\",\"7.4931479\",\"51.613";
_crgpx._setbounds("51.8661866","7.4931479","51.6139841","7.3194265");
 //BA.debugLineNum = 260;BA.debugLine="Fix_rtes.Initialize";
_fix_rtes.Initialize();
 //BA.debugLineNum = 261;BA.debugLine="Fix_rtes.AddAll(Array As String(\"Hinweg\",\"Zum Sc";
_fix_rtes.AddAll(anywheresoftware.b4a.keywords.Common.ArrayToList(new String[]{"Hinweg","Zum Schiffshebewerk Henrichenburg","true","51.8660035","7.4800899","2007-03-31 18:52:54","Erlengrund3611","Erlengrund 3611","Erlengrund 3611","Residence"}));
 //BA.debugLineNum = 264;BA.debugLine="CRGpx.gpxx_subclass(\"000000000000fffffffffffffff";
_crgpx._gpxx_subclass("000000000000ffffffffffffffffffffffff");
 //BA.debugLineNum = 269;BA.debugLine="Dim gpxx_rpt As Map";
_gpxx_rpt = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 270;BA.debugLine="gpxx_rpt.Initialize";
_gpxx_rpt.Initialize();
 //BA.debugLineNum = 271;BA.debugLine="gpxx_rpt.Put(\"lat\",\"51.8657684\")";
_gpxx_rpt.Put((Object)("lat"),(Object)("51.8657684"));
 //BA.debugLineNum = 272;BA.debugLine="gpxx_rpt.Put(\"lon\",\"7.4800587\")";
_gpxx_rpt.Put((Object)("lon"),(Object)("7.4800587"));
 //BA.debugLineNum = 273;BA.debugLine="gpxx_rpt.Put(\"sub\",\"06000f544d00163811001f062900";
_gpxx_rpt.Put((Object)("sub"),(Object)("06000f544d00163811001f062900aef12800"));
 //BA.debugLineNum = 274;BA.debugLine="CRGpx.gpxx_rptsubclass(gpxx_rpt)";
_crgpx._gpxx_rptsubclass(_gpxx_rpt);
 //BA.debugLineNum = 277;BA.debugLine="Dim gpxx_rpt As Map";
_gpxx_rpt = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 278;BA.debugLine="gpxx_rpt.Initialize";
_gpxx_rpt.Initialize();
 //BA.debugLineNum = 279;BA.debugLine="gpxx_rpt.Put(\"lat\",\"51.8657684\")";
_gpxx_rpt.Put((Object)("lat"),(Object)("51.8657684"));
 //BA.debugLineNum = 280;BA.debugLine="gpxx_rpt.Put(\"lon\",\"7.4800587\")";
_gpxx_rpt.Put((Object)("lon"),(Object)("7.4800587"));
 //BA.debugLineNum = 281;BA.debugLine="CRGpx.gpxx_rpt(gpxx_rpt)";
_crgpx._gpxx_rpt(_gpxx_rpt);
 //BA.debugLineNum = 288;BA.debugLine="If CRGpx.CreateFileRoutes(path, filename, Fix_tr";
if (_crgpx._createfileroutes(_path,_filename,_fix_trkname,_displaycolor,_fix_trkcmt,_fix_time,_fix_accuracy,_fix_altitude,_fix_wpts,_fix_rtes,_html_schemas)) { 
 //BA.debugLineNum = 291;BA.debugLine="Msgbox(\"C R E A T E\" & CRLF & filename, \"IV. Me";
anywheresoftware.b4a.keywords.Common.Msgbox("C R E A T E"+anywheresoftware.b4a.keywords.Common.CRLF+_filename,"IV. Message",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 294;BA.debugLine="Msgbox(\"E R R O R\" & CRLF & LastException.Messa";
anywheresoftware.b4a.keywords.Common.Msgbox("E R R O R"+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"IV. Message",mostCurrent.activityBA);
 };
 };
 //BA.debugLineNum = 297;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim SFGpx As StringFunctionGPX";
_sfgpx = new b4a.example.stringfunctiongpx();
 //BA.debugLineNum = 20;BA.debugLine="Dim CRGpx As CreatorGPX";
_crgpx = new b4a.example.creatorgpx();
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return "";
}
}
